/*************************************************************
 * This file was automatically generated on 2012-04-11.      *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generator git on tinkerforge.com                   *
 *************************************************************/

namespace Tinkerforge
{
	public class BrickMaster : Device 
	{
		private static byte TYPE_GET_STACK_VOLTAGE = 1;
		private static byte TYPE_GET_STACK_CURRENT = 2;
		private static byte TYPE_SET_EXTENSION_TYPE = 3;
		private static byte TYPE_GET_EXTENSION_TYPE = 4;
		private static byte TYPE_IS_CHIBI_PRESENT = 5;
		private static byte TYPE_SET_CHIBI_ADDRESS = 6;
		private static byte TYPE_GET_CHIBI_ADDRESS = 7;
		private static byte TYPE_SET_CHIBI_MASTER_ADDRESS = 8;
		private static byte TYPE_GET_CHIBI_MASTER_ADDRESS = 9;
		private static byte TYPE_SET_CHIBI_SLAVE_ADDRESS = 10;
		private static byte TYPE_GET_CHIBI_SLAVE_ADDRESS = 11;
		private static byte TYPE_GET_CHIBI_SIGNAL_STRENGTH = 12;
		private static byte TYPE_GET_CHIBI_ERROR_LOG = 13;
		private static byte TYPE_SET_CHIBI_FREQUENCY = 14;
		private static byte TYPE_GET_CHIBI_FREQUENCY = 15;
		private static byte TYPE_SET_CHIBI_CHANNEL = 16;
		private static byte TYPE_GET_CHIBI_CHANNEL = 17;


		public BrickMaster(string uid) : base(uid) 
		{
			this.bindingVersion[0] = 1;
			this.bindingVersion[1] = 1;
			this.bindingVersion[2] = 0;

		}

		public void GetStackVoltage(out ushort voltage)
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_STACK_VOLTAGE, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			ipcon.Write(this, data_, TYPE_GET_STACK_VOLTAGE, true);

			byte[] answer;
			if(!answerQueue.TryDequeue(out answer, IPConnection.TIMEOUT_ANSWER))
			{
				throw new TimeoutException("Did not receive answer for GetStackVoltage in time");
			}

			voltage = LEConverter.UShortFrom(4, answer);

			writeEvent.Set();
		}

		public void GetStackCurrent(out ushort current)
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_STACK_CURRENT, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			ipcon.Write(this, data_, TYPE_GET_STACK_CURRENT, true);

			byte[] answer;
			if(!answerQueue.TryDequeue(out answer, IPConnection.TIMEOUT_ANSWER))
			{
				throw new TimeoutException("Did not receive answer for GetStackCurrent in time");
			}

			current = LEConverter.UShortFrom(4, answer);

			writeEvent.Set();
		}

		public void SetExtensionType(byte extension, uint exttype)
		{
			byte[] data_ = new byte[9];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_SET_EXTENSION_TYPE, 1, data_);
			LEConverter.To((ushort)9, 2, data_);
			LEConverter.To(extension, 4, data_);
			LEConverter.To(exttype, 5, data_);

			ipcon.Write(this, data_, TYPE_SET_EXTENSION_TYPE, false);
		}

		public void GetExtensionType(byte extension, out uint exttype)
		{
			byte[] data_ = new byte[5];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_EXTENSION_TYPE, 1, data_);
			LEConverter.To((ushort)5, 2, data_);
			LEConverter.To(extension, 4, data_);

			ipcon.Write(this, data_, TYPE_GET_EXTENSION_TYPE, true);

			byte[] answer;
			if(!answerQueue.TryDequeue(out answer, IPConnection.TIMEOUT_ANSWER))
			{
				throw new TimeoutException("Did not receive answer for GetExtensionType in time");
			}

			exttype = LEConverter.UIntFrom(4, answer);

			writeEvent.Set();
		}

		public void IsChibiPresent(out bool present)
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_IS_CHIBI_PRESENT, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			ipcon.Write(this, data_, TYPE_IS_CHIBI_PRESENT, true);

			byte[] answer;
			if(!answerQueue.TryDequeue(out answer, IPConnection.TIMEOUT_ANSWER))
			{
				throw new TimeoutException("Did not receive answer for IsChibiPresent in time");
			}

			present = LEConverter.BoolFrom(4, answer);

			writeEvent.Set();
		}

		public void SetChibiAddress(byte address)
		{
			byte[] data_ = new byte[5];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_SET_CHIBI_ADDRESS, 1, data_);
			LEConverter.To((ushort)5, 2, data_);
			LEConverter.To(address, 4, data_);

			ipcon.Write(this, data_, TYPE_SET_CHIBI_ADDRESS, false);
		}

		public void GetChibiAddress(out byte address)
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_CHIBI_ADDRESS, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			ipcon.Write(this, data_, TYPE_GET_CHIBI_ADDRESS, true);

			byte[] answer;
			if(!answerQueue.TryDequeue(out answer, IPConnection.TIMEOUT_ANSWER))
			{
				throw new TimeoutException("Did not receive answer for GetChibiAddress in time");
			}

			address = LEConverter.ByteFrom(4, answer);

			writeEvent.Set();
		}

		public void SetChibiMasterAddress(byte address)
		{
			byte[] data_ = new byte[5];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_SET_CHIBI_MASTER_ADDRESS, 1, data_);
			LEConverter.To((ushort)5, 2, data_);
			LEConverter.To(address, 4, data_);

			ipcon.Write(this, data_, TYPE_SET_CHIBI_MASTER_ADDRESS, false);
		}

		public void GetChibiMasterAddress(out byte address)
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_CHIBI_MASTER_ADDRESS, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			ipcon.Write(this, data_, TYPE_GET_CHIBI_MASTER_ADDRESS, true);

			byte[] answer;
			if(!answerQueue.TryDequeue(out answer, IPConnection.TIMEOUT_ANSWER))
			{
				throw new TimeoutException("Did not receive answer for GetChibiMasterAddress in time");
			}

			address = LEConverter.ByteFrom(4, answer);

			writeEvent.Set();
		}

		public void SetChibiSlaveAddress(byte num, byte address)
		{
			byte[] data_ = new byte[6];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_SET_CHIBI_SLAVE_ADDRESS, 1, data_);
			LEConverter.To((ushort)6, 2, data_);
			LEConverter.To(num, 4, data_);
			LEConverter.To(address, 5, data_);

			ipcon.Write(this, data_, TYPE_SET_CHIBI_SLAVE_ADDRESS, false);
		}

		public void GetChibiSlaveAddress(byte num, out byte address)
		{
			byte[] data_ = new byte[5];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_CHIBI_SLAVE_ADDRESS, 1, data_);
			LEConverter.To((ushort)5, 2, data_);
			LEConverter.To(num, 4, data_);

			ipcon.Write(this, data_, TYPE_GET_CHIBI_SLAVE_ADDRESS, true);

			byte[] answer;
			if(!answerQueue.TryDequeue(out answer, IPConnection.TIMEOUT_ANSWER))
			{
				throw new TimeoutException("Did not receive answer for GetChibiSlaveAddress in time");
			}

			address = LEConverter.ByteFrom(4, answer);

			writeEvent.Set();
		}

		public void GetChibiSignalStrength(out byte signalStrength)
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_CHIBI_SIGNAL_STRENGTH, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			ipcon.Write(this, data_, TYPE_GET_CHIBI_SIGNAL_STRENGTH, true);

			byte[] answer;
			if(!answerQueue.TryDequeue(out answer, IPConnection.TIMEOUT_ANSWER))
			{
				throw new TimeoutException("Did not receive answer for GetChibiSignalStrength in time");
			}

			signalStrength = LEConverter.ByteFrom(4, answer);

			writeEvent.Set();
		}

		public void GetChibiErrorLog(out ushort underrun, out ushort crcError, out ushort noAck, out ushort overflow)
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_CHIBI_ERROR_LOG, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			ipcon.Write(this, data_, TYPE_GET_CHIBI_ERROR_LOG, true);

			byte[] answer;
			if(!answerQueue.TryDequeue(out answer, IPConnection.TIMEOUT_ANSWER))
			{
				throw new TimeoutException("Did not receive answer for GetChibiErrorLog in time");
			}

			underrun = LEConverter.UShortFrom(4, answer);
			crcError = LEConverter.UShortFrom(6, answer);
			noAck = LEConverter.UShortFrom(8, answer);
			overflow = LEConverter.UShortFrom(10, answer);

			writeEvent.Set();
		}

		public void SetChibiFrequency(byte frequency)
		{
			byte[] data_ = new byte[5];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_SET_CHIBI_FREQUENCY, 1, data_);
			LEConverter.To((ushort)5, 2, data_);
			LEConverter.To(frequency, 4, data_);

			ipcon.Write(this, data_, TYPE_SET_CHIBI_FREQUENCY, false);
		}

		public void GetChibiFrequency(out byte frequency)
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_CHIBI_FREQUENCY, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			ipcon.Write(this, data_, TYPE_GET_CHIBI_FREQUENCY, true);

			byte[] answer;
			if(!answerQueue.TryDequeue(out answer, IPConnection.TIMEOUT_ANSWER))
			{
				throw new TimeoutException("Did not receive answer for GetChibiFrequency in time");
			}

			frequency = LEConverter.ByteFrom(4, answer);

			writeEvent.Set();
		}

		public void SetChibiChannel(byte channel)
		{
			byte[] data_ = new byte[5];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_SET_CHIBI_CHANNEL, 1, data_);
			LEConverter.To((ushort)5, 2, data_);
			LEConverter.To(channel, 4, data_);

			ipcon.Write(this, data_, TYPE_SET_CHIBI_CHANNEL, false);
		}

		public void GetChibiChannel(out byte channel)
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(TYPE_GET_CHIBI_CHANNEL, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			ipcon.Write(this, data_, TYPE_GET_CHIBI_CHANNEL, true);

			byte[] answer;
			if(!answerQueue.TryDequeue(out answer, IPConnection.TIMEOUT_ANSWER))
			{
				throw new TimeoutException("Did not receive answer for GetChibiChannel in time");
			}

			channel = LEConverter.ByteFrom(4, answer);

			writeEvent.Set();
		}

		public void GetVersion(out string name, out byte[] firmwareVersion, out byte[] bindingVersion)
		{{
			name = this.name;
			firmwareVersion = this.firmwareVersion;
			bindingVersion = this.bindingVersion;
		}}

		public void RegisterCallback(System.Delegate d)
		{
		}
	}
}
